package geo;
require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(tan rad atan asin asind acos print_det cnumber $pi phi theta rad2deg);
#@EXPORT = qw(tan rad atan asin asind print_det cnumber $pi);

$pi = 3.141592653589793238;
use Math::Trig;

# Better to use: use Math::Trig;
# sub tan { sin($_[0]) / cos($_[0])  }
# sub rad { $_[0]*$pi/180.0  }
# sub atan {atan2($_[0],1)}
# sub asin {my $z = $_[0]; atan2($z, sqrt(1-$z*$z))}
sub asind {asin($_[0])*180/$pi}
# sub asin {my $z = $_[0]; atan2($z, sqrt(1-$z*$z))}


sub phi
{
 my $x = $_[0];
 my $y = $_[1];
 my $z = $_[2];

 my $phi = 0.0;
 if($y > 0.0)
 {
     $phi = acos($x/sqrt($x*$x+$y*$y));
 }
 if($y < 0.0)
 {
    $phi =  2*3.141592654 - acos($x/sqrt($x*$x+$y*$y));
 }
 if($y == 0.0 && $x<0)
 {
    $phi =  2*3.141592654;
 }
 return $phi;
}

sub theta
{
 my $x = $_[0];
 my $y = $_[1];
 my $z = $_[2];

 my $theta = 0.0;

 if($x*$x+$y*$y+$z*$z)
 {
   $theta =  acos($z/sqrt($x*$x+$y*$y+$z*$z));
 }

 return $theta;
}


sub cnumber
{
 my $s   = shift;
 my $max = shift;

 my $zeros = "";
 if($s < 9 && $max == 10)  { $zeros =  "0"; }
 if($s < 9 && $max == 100) { $zeros = "00"; }

 if($max == 100 && $s > 9) { $zeros =  "0"; }


 my $segment_n = $s + 1;
 return "$zeros$segment_n";
}

sub print_det
{
 my (%det)  = %{$_[0]};
 my $file   = $_[1];

 open(INFO, ">>$file");

 print INFO $det{"name"}."\t";
 print INFO $det{"mother"}."\t";
 print INFO $det{"description"}."\t";
 print INFO $det{"pos"}."\t";
 print INFO $det{"rotation"}."\t";
 print INFO $det{"color"}."\t";
 print INFO $det{"type"}."\t";
 print INFO $det{"dimensions"}."\t";
 print INFO $det{"material"}."\t";
 print INFO $det{"mfield"}."\t";
 print INFO $det{"ncopy"}."\t";
 print INFO $det{"pMany"}."\t";
 print INFO $det{"exist"}."\t";
 print INFO $det{"visible"}."\t";
 print INFO $det{"style"}."\t";
 print INFO $det{"sensitivity"}."\t";
 print INFO $det{"hit_type"}."\t";
 print INFO $det{"identifiers"}."\t";
 print INFO $det{"rmin"}."\t";
 print INFO $det{"rmax"}."\n";

 close(INFO);
}

sub rad
{
 my $angle     = $_[0];
 my $angle_rad = $_[0]*$pi/180;
}

1;





